/**
 * DevExtreme (cjs/renovation/ui/grids/data_grid_light/data_grid_light.js)
 * Version: 22.1.0 (build 22018-0314)
 * Build date: Tue Jan 18 2022
 *
 * Copyright (c) 2012 - 2022 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.viewFunction = exports.VisibleItems = exports.VisibleColumns = exports.TotalCount = exports.KeyExprPlugin = exports.DataSource = exports.DataGridLightProps = exports.DataGridLight = void 0;
var _inferno = require("inferno");
var _inferno2 = require("@devextreme/runtime/inferno");
var _context = require("../../../utils/plugin/context");
var _widget = require("../../common/widget");
var _base_props = require("../../common/base_props");
var _table_content = require("./views/table_content");
var _table_header = require("./views/table_header");
var _footer = require("./views/footer");
var _excluded = ["accessKey", "activeStateEnabled", "children", "className", "columns", "dataSource", "disabled", "focusStateEnabled", "height", "hint", "hoverStateEnabled", "keyExpr", "onClick", "onKeyDown", "rtlEnabled", "tabIndex", "visible", "width"];

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    Object.defineProperty(Constructor, "prototype", {
        writable: false
    });
    return Constructor
}

function _assertThisInitialized(self) {
    if (void 0 === self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return self
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}
var VisibleItems = (0, _context.createGetter)([]);
exports.VisibleItems = VisibleItems;
var VisibleColumns = (0, _context.createGetter)([]);
exports.VisibleColumns = VisibleColumns;
var DataSource = (0, _context.createValue)();
exports.DataSource = DataSource;
var KeyExprPlugin = (0, _context.createValue)();
exports.KeyExprPlugin = KeyExprPlugin;
var TotalCount = (0, _context.createValue)();
exports.TotalCount = TotalCount;
var viewFunction = function(viewModel) {
    return (0, _inferno.normalizeProps)((0, _inferno.createComponentVNode)(2, _widget.Widget, _extends({
        accessKey: viewModel.props.accessKey,
        activeStateEnabled: viewModel.props.activeStateEnabled,
        aria: viewModel.aria,
        disabled: viewModel.props.disabled,
        focusStateEnabled: viewModel.props.focusStateEnabled,
        height: viewModel.props.height,
        hint: viewModel.props.hint,
        hoverStateEnabled: viewModel.props.hoverStateEnabled,
        rtlEnabled: viewModel.props.rtlEnabled,
        tabIndex: viewModel.props.tabIndex,
        visible: viewModel.props.visible,
        width: viewModel.props.width
    }, viewModel.restAttributes, {
        children: (0, _inferno.createVNode)(1, "div", "dx-datagrid dx-gridbase-container", [(0, _inferno.createComponentVNode)(2, _table_header.TableHeader, {
            columns: viewModel.visibleColumns
        }), (0, _inferno.createComponentVNode)(2, _table_content.TableContent, {
            columns: viewModel.visibleColumns,
            dataSource: viewModel.visibleItems
        }), (0, _inferno.createComponentVNode)(2, _footer.Footer), viewModel.props.children], 0, {
            role: "grid",
            "aria-label": "Data grid"
        })
    })))
};
exports.viewFunction = viewFunction;
var DataGridLightProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(_base_props.BaseWidgetProps), Object.getOwnPropertyDescriptors({
    dataSource: Object.freeze([]),
    columns: Object.freeze([])
})));
exports.DataGridLightProps = DataGridLightProps;
var aria = {
    role: "presentation"
};
var DataGridLight = function(_InfernoWrapperCompon) {
    _inheritsLoose(DataGridLight, _InfernoWrapperCompon);

    function DataGridLight(props) {
        var _this;
        _this = _InfernoWrapperCompon.call(this, props) || this;
        _this.plugins = new _context.Plugins;
        _this.__getterCache = {};
        _this.state = {
            visibleItems: [],
            visibleColumns: []
        };
        _this.updateTotalCount = _this.updateTotalCount.bind(_assertThisInitialized(_this));
        _this.updateVisibleItems = _this.updateVisibleItems.bind(_assertThisInitialized(_this));
        _this.setDataSourceToVisibleItems = _this.setDataSourceToVisibleItems.bind(_assertThisInitialized(_this));
        _this.updateVisibleColumns = _this.updateVisibleColumns.bind(_assertThisInitialized(_this));
        _this.setInitialColumnsToVisibleColumns = _this.setInitialColumnsToVisibleColumns.bind(_assertThisInitialized(_this));
        _this.updateKeyExpr = _this.updateKeyExpr.bind(_assertThisInitialized(_this));
        _this.updateDataSource = _this.updateDataSource.bind(_assertThisInitialized(_this));
        return _this
    }
    var _proto = DataGridLight.prototype;
    _proto.createEffects = function() {
        return [new _inferno2.InfernoEffect(this.updateTotalCount, [this.plugins, this.props.dataSource]), new _inferno2.InfernoEffect(this.updateVisibleItems, [this.plugins]), new _inferno2.InfernoEffect(this.setDataSourceToVisibleItems, [this.plugins, this.props.dataSource]), new _inferno2.InfernoEffect(this.updateVisibleColumns, [this.plugins]), new _inferno2.InfernoEffect(this.setInitialColumnsToVisibleColumns, [this.plugins, this.props.columns]), new _inferno2.InfernoEffect(this.updateKeyExpr, [this.plugins, this.props.keyExpr]), new _inferno2.InfernoEffect(this.updateDataSource, [this.plugins, this.props.dataSource]), (0, _inferno2.createReRenderEffect)()]
    };
    _proto.updateEffects = function() {
        var _this$_effects$, _this$_effects$2, _this$_effects$3, _this$_effects$4, _this$_effects$5, _this$_effects$6, _this$_effects$7;
        null === (_this$_effects$ = this._effects[0]) || void 0 === _this$_effects$ ? void 0 : _this$_effects$.update([this.plugins, this.props.dataSource]);
        null === (_this$_effects$2 = this._effects[1]) || void 0 === _this$_effects$2 ? void 0 : _this$_effects$2.update([this.plugins]);
        null === (_this$_effects$3 = this._effects[2]) || void 0 === _this$_effects$3 ? void 0 : _this$_effects$3.update([this.plugins, this.props.dataSource]);
        null === (_this$_effects$4 = this._effects[3]) || void 0 === _this$_effects$4 ? void 0 : _this$_effects$4.update([this.plugins]);
        null === (_this$_effects$5 = this._effects[4]) || void 0 === _this$_effects$5 ? void 0 : _this$_effects$5.update([this.plugins, this.props.columns]);
        null === (_this$_effects$6 = this._effects[5]) || void 0 === _this$_effects$6 ? void 0 : _this$_effects$6.update([this.plugins, this.props.keyExpr]);
        null === (_this$_effects$7 = this._effects[6]) || void 0 === _this$_effects$7 ? void 0 : _this$_effects$7.update([this.plugins, this.props.dataSource])
    };
    _proto.getChildContext = function() {
        return _extends({}, this.context, {
            PluginsContext: this.plugins
        })
    };
    _proto.updateTotalCount = function() {
        this.plugins.set(TotalCount, this.props.dataSource.length)
    };
    _proto.updateVisibleItems = function() {
        var _this2 = this;
        return this.plugins.watch(VisibleItems, (function(items) {
            _this2.setState((function(__state_argument) {
                return {
                    visibleItems: items
                }
            }))
        }))
    };
    _proto.setDataSourceToVisibleItems = function() {
        var _this3 = this;
        return this.plugins.extend(VisibleItems, -1, (function() {
            return _this3.props.dataSource
        }))
    };
    _proto.updateVisibleColumns = function() {
        var _this4 = this;
        return this.plugins.watch(VisibleColumns, (function(columns) {
            _this4.setState((function(__state_argument) {
                return {
                    visibleColumns: columns
                }
            }))
        }))
    };
    _proto.setInitialColumnsToVisibleColumns = function() {
        var _this5 = this;
        return this.plugins.extend(VisibleColumns, -1, (function() {
            return _this5.columns
        }))
    };
    _proto.updateKeyExpr = function() {
        this.plugins.set(KeyExprPlugin, this.props.keyExpr)
    };
    _proto.updateDataSource = function() {
        this.plugins.set(DataSource, this.props.dataSource)
    };
    _proto.componentWillUpdate = function(nextProps, nextState, context) {
        _InfernoWrapperCompon.prototype.componentWillUpdate.call(this);
        if (this.props.columns !== nextProps.columns) {
            this.__getterCache.columns = void 0
        }
    };
    _proto.render = function() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            visibleItems: this.state.visibleItems,
            visibleColumns: this.state.visibleColumns,
            plugins: this.plugins,
            aria: this.aria,
            columns: this.columns,
            restAttributes: this.restAttributes
        })
    };
    _createClass(DataGridLight, [{
        key: "aria",
        get: function() {
            return aria
        }
    }, {
        key: "columns",
        get: function() {
            var _this6 = this;
            if (void 0 !== this.__getterCache.columns) {
                return this.__getterCache.columns
            }
            return this.__getterCache.columns = (userColumns = _this6.props.columns, userColumns.map((function(userColumn) {
                return {
                    dataField: userColumn
                }
            })));
            var userColumns
        }
    }, {
        key: "restAttributes",
        get: function() {
            var _this$props = this.props,
                restProps = (_this$props.accessKey, _this$props.activeStateEnabled, _this$props.children, _this$props.className, _this$props.columns, _this$props.dataSource, _this$props.disabled, _this$props.focusStateEnabled, _this$props.height, _this$props.hint, _this$props.hoverStateEnabled, _this$props.keyExpr, _this$props.onClick, _this$props.onKeyDown, _this$props.rtlEnabled, _this$props.tabIndex, _this$props.visible, _this$props.width, _objectWithoutProperties(_this$props, _excluded));
            return restProps
        }
    }]);
    return DataGridLight
}(_inferno2.InfernoWrapperComponent);
exports.DataGridLight = DataGridLight;
DataGridLight.defaultProps = DataGridLightProps;
