/**
 * DevExtreme (cjs/renovation/ui/grids/data_grid_light/widgets/header_row.js)
 * Version: 22.1.0 (build 22018-0314)
 * Build date: Tue Jan 18 2022
 *
 * Copyright (c) 2012 - 2022 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.viewFunction = exports.HeaderRowProps = exports.HeaderRow = void 0;
var _inferno = require("inferno");
var _inferno2 = require("@devextreme/runtime/inferno");
var _excluded = ["columns"];

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    Object.defineProperty(Constructor, "prototype", {
        writable: false
    });
    return Constructor
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}
var viewFunction = function(viewModel) {
    return (0, _inferno.createVNode)(1, "tr", "dx-row dx-column-lines dx-header-row", viewModel.props.columns.map((function(column, index) {
        var HeaderTemplate = column.headerTemplate;
        return (0, _inferno.createVNode)(1, "td", "dx-datagrid-action dx-cell-focus-disabled", (0, _inferno.createVNode)(1, "div", "dx-datagrid-text-content dx-text-content-alignment-left", HeaderTemplate ? (0, _inferno.createComponentVNode)(2, HeaderTemplate) : column.dataField, 0, {
            role: "presentation"
        }), 2, {
            "aria-selected": "false",
            role: "columnheader",
            id: "dx-col-".concat(index + 1),
            "aria-label": "Column ".concat(column.dataField),
            "aria-sort": "none",
            tabIndex: 0
        }, index)
    })), 0, {
        role: "row"
    })
};
exports.viewFunction = viewFunction;
var HeaderRowProps = {
    columns: Object.freeze([])
};
exports.HeaderRowProps = HeaderRowProps;
var HeaderRow = function(_BaseInfernoComponent) {
    _inheritsLoose(HeaderRow, _BaseInfernoComponent);

    function HeaderRow(props) {
        var _this;
        _this = _BaseInfernoComponent.call(this, props) || this;
        _this.state = {};
        return _this
    }
    var _proto = HeaderRow.prototype;
    _proto.render = function() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            restAttributes: this.restAttributes
        })
    };
    _createClass(HeaderRow, [{
        key: "restAttributes",
        get: function() {
            var _this$props = this.props,
                restProps = (_this$props.columns, _objectWithoutProperties(_this$props, _excluded));
            return restProps
        }
    }]);
    return HeaderRow
}(_inferno2.BaseInfernoComponent);
exports.HeaderRow = HeaderRow;
HeaderRow.defaultProps = HeaderRowProps;
