/**
 * DevExtreme (esm/renovation/ui/grids/data_grid_light/paging/plugins.js)
 * Version: 22.1.0 (build 22018-0314)
 * Build date: Tue Jan 18 2022
 *
 * Copyright (c) 2012 - 2022 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import {
    createValue,
    createSelector
} from "../../../../utils/plugin/context";
import {
    TotalCount
} from "../data_grid_light";
export var PageIndex = createValue();
export var SetPageIndex = createValue();
export var PageSize = createValue();
export var SetPageSize = createValue();
export var PageCount = createSelector([TotalCount, PageSize], (totalCount, pageSize) => {
    if ("all" === pageSize) {
        return 1
    }
    return Math.ceil(totalCount / pageSize)
});
