/**
 * DevExtreme (esm/renovation/ui/grids/data_grid_light/views/table_content.js)
 * Version: 22.1.0 (build 22018-0314)
 * Build date: Tue Jan 18 2022
 *
 * Copyright (c) 2012 - 2022 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["columns", "dataSource"];
import {
    createVNode,
    createFragment,
    createComponentVNode
} from "inferno";
import {
    Fragment
} from "inferno";
import {
    InfernoEffect,
    InfernoComponent
} from "@devextreme/runtime/inferno";
import {
    Table
} from "../widgets/table";
import {
    DataRow
} from "../widgets/data_row";
import {
    createValue,
    PluginsContext
} from "../../../../utils/plugin/context";
import eventsEngine from "../../../../../events/core/events_engine";
import {
    name as clickEvent
} from "../../../../../events/click";
export var viewFunction = viewModel => createVNode(1, "div", "dx-datagrid-rowsview dx-datagrid-nowrap dx-datagrid-after-headers", createVNode(1, "div", "dx-datagrid-content", createComponentVNode(2, Table, {
    children: createFragment(viewModel.props.dataSource.map((data, rowIndex) => createComponentVNode(2, DataRow, {
        data: data,
        rowIndex: rowIndex,
        columns: viewModel.props.columns
    })), 0)
}), 2, null, null, viewModel.divRef), 2, {
    role: "presentation"
});
export var RowClick = createValue();
export var TableContentProps = {
    dataSource: Object.freeze([]),
    columns: Object.freeze([])
};
import {
    createRef as infernoCreateRef
} from "inferno";
export class TableContent extends InfernoComponent {
    constructor(props) {
        super(props);
        this.state = {};
        this.divRef = infernoCreateRef();
        this.subscribeToRowClick = this.subscribeToRowClick.bind(this);
        this.onRowClick = this.onRowClick.bind(this)
    }
    get plugins() {
        if ("PluginsContext" in this.context) {
            return this.context.PluginsContext
        }
        return PluginsContext
    }
    createEffects() {
        return [new InfernoEffect(this.subscribeToRowClick, [this.plugins, this.props.dataSource])]
    }
    updateEffects() {
        var _this$_effects$;
        null === (_this$_effects$ = this._effects[0]) || void 0 === _this$_effects$ ? void 0 : _this$_effects$.update([this.plugins, this.props.dataSource])
    }
    subscribeToRowClick() {
        eventsEngine.on(this.divRef.current, clickEvent, ".dx-row", this.onRowClick);
        return () => eventsEngine.off(this.divRef.current, clickEvent, this.onRowClick)
    }
    onRowClick(e) {
        var allRows = this.divRef.current.getElementsByClassName("dx-row");
        var index = Array.from(allRows).indexOf(e.currentTarget);
        if (index >= 0) {
            this.plugins.callAction(RowClick, this.props.dataSource[index])
        }
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, _excluded);
        return restProps
    }
    render() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            divRef: this.divRef,
            plugins: this.plugins,
            onRowClick: this.onRowClick,
            restAttributes: this.restAttributes
        })
    }
}
TableContent.defaultProps = TableContentProps;
