/**
 * DevExtreme (esm/renovation/ui/grids/data_grid_light/widgets/data_row.js)
 * Version: 22.1.0 (build 22018-0314)
 * Build date: Tue Jan 18 2022
 *
 * Copyright (c) 2012 - 2022 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
var _excluded = ["columns", "data", "rowIndex"];
import {
    createVNode,
    createComponentVNode,
    normalizeProps
} from "inferno";
import {
    InfernoEffect,
    InfernoComponent
} from "@devextreme/runtime/inferno";
import {
    combineClasses
} from "../../../../utils/combine_classes";
import {
    createGetter,
    PluginsContext
} from "../../../../utils/plugin/context";
export var DataRowPropertiesGetter = createGetter(() => ({}));
export var DataRowClassesGetter = createGetter(() => ({}));
export var viewFunction = viewModel => normalizeProps(createVNode(1, "tr", viewModel.cssClasses, viewModel.props.columns.map((column, index) => {
    var {
        cellTemplate: CellTemplate,
        dataField: dataField
    } = column;
    return createVNode(1, "td", null, CellTemplate ? createComponentVNode(2, CellTemplate, {
        data: viewModel.props.data
    }) : dataField && "".concat(viewModel.props.data[dataField]), 0, {
        "aria-selected": "false",
        role: "gridcell"
    }, index)
}), 0, _extends({
    role: "row",
    "aria-selected": "false"
}, viewModel.additionalParams)));
export var DataRowProps = {
    data: Object.freeze({}),
    rowIndex: 0,
    columns: Object.freeze([])
};
export class DataRow extends InfernoComponent {
    constructor(props) {
        super(props);
        this.state = {
            additionalParams: {},
            additionalClasses: {}
        };
        this.watchAdditionalParams = this.watchAdditionalParams.bind(this);
        this.watchAdditionalClasses = this.watchAdditionalClasses.bind(this)
    }
    get plugins() {
        if ("PluginsContext" in this.context) {
            return this.context.PluginsContext
        }
        return PluginsContext
    }
    createEffects() {
        return [new InfernoEffect(this.watchAdditionalParams, [this.plugins, this.props.data]), new InfernoEffect(this.watchAdditionalClasses, [this.plugins, this.props.data])]
    }
    updateEffects() {
        var _this$_effects$, _this$_effects$2;
        null === (_this$_effects$ = this._effects[0]) || void 0 === _this$_effects$ ? void 0 : _this$_effects$.update([this.plugins, this.props.data]);
        null === (_this$_effects$2 = this._effects[1]) || void 0 === _this$_effects$2 ? void 0 : _this$_effects$2.update([this.plugins, this.props.data])
    }
    watchAdditionalParams() {
        return this.plugins.watch(DataRowPropertiesGetter, getter => {
            this.setState(__state_argument => ({
                additionalParams: getter(this.props.data)
            }))
        })
    }
    watchAdditionalClasses() {
        return this.plugins.watch(DataRowClassesGetter, getter => {
            this.setState(__state_argument => ({
                additionalClasses: getter(this.props.data)
            }))
        })
    }
    get cssClasses() {
        return combineClasses(_extends({
            "dx-row": true,
            "dx-data-row": true,
            "dx-column-lines": true
        }, this.state.additionalClasses))
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, _excluded);
        return restProps
    }
    render() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            additionalParams: this.state.additionalParams,
            additionalClasses: this.state.additionalClasses,
            plugins: this.plugins,
            cssClasses: this.cssClasses,
            restAttributes: this.restAttributes
        })
    }
}
DataRow.defaultProps = DataRowProps;
