/**
 * DevExtreme (esm/renovation/ui/grids/data_grid_light/widgets/header_row.js)
 * Version: 22.1.0 (build 22018-0314)
 * Build date: Tue Jan 18 2022
 *
 * Copyright (c) 2012 - 2022 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["columns"];
import {
    createVNode,
    createComponentVNode
} from "inferno";
import {
    BaseInfernoComponent
} from "@devextreme/runtime/inferno";
export var viewFunction = viewModel => createVNode(1, "tr", "dx-row dx-column-lines dx-header-row", viewModel.props.columns.map((column, index) => {
    var HeaderTemplate = column.headerTemplate;
    return createVNode(1, "td", "dx-datagrid-action dx-cell-focus-disabled", createVNode(1, "div", "dx-datagrid-text-content dx-text-content-alignment-left", HeaderTemplate ? createComponentVNode(2, HeaderTemplate) : column.dataField, 0, {
        role: "presentation"
    }), 2, {
        "aria-selected": "false",
        role: "columnheader",
        id: "dx-col-".concat(index + 1),
        "aria-label": "Column ".concat(column.dataField),
        "aria-sort": "none",
        tabIndex: 0
    }, index)
}), 0, {
    role: "row"
});
export var HeaderRowProps = {
    columns: Object.freeze([])
};
export class HeaderRow extends BaseInfernoComponent {
    constructor(props) {
        super(props);
        this.state = {}
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, _excluded);
        return restProps
    }
    render() {
        var props = this.props;
        return viewFunction({
            props: _extends({}, props),
            restAttributes: this.restAttributes
        })
    }
}
HeaderRow.defaultProps = HeaderRowProps;
