/**
 * DevExtreme (esm/renovation/utils/plugin/getter_extender.js)
 * Version: 22.1.0 (build 22018-0314)
 * Build date: Tue Jan 18 2022
 *
 * Copyright (c) 2012 - 2022 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["func", "order", "type"];
import {
    createFragment
} from "inferno";
import {
    InfernoEffect,
    InfernoComponent
} from "@devextreme/runtime/inferno";
import {
    PluginsContext
} from "./context";
export var viewFunction = () => createFragment();
export var GetterExtenderProps = {};
export class GetterExtender extends InfernoComponent {
    constructor(props) {
        super(props);
        this.state = {};
        this.updateExtender = this.updateExtender.bind(this)
    }
    get plugins() {
        if ("PluginsContext" in this.context) {
            return this.context.PluginsContext
        }
        return PluginsContext
    }
    createEffects() {
        return [new InfernoEffect(this.updateExtender, [this.plugins, this.props.type, this.props.order, this.props.func])]
    }
    updateEffects() {
        var _this$_effects$;
        null === (_this$_effects$ = this._effects[0]) || void 0 === _this$_effects$ ? void 0 : _this$_effects$.update([this.plugins, this.props.type, this.props.order, this.props.func])
    }
    updateExtender() {
        return this.plugins.extend(this.props.type, this.props.order, this.props.func)
    }
    get restAttributes() {
        var _this$props = this.props,
            restProps = _objectWithoutPropertiesLoose(_this$props, _excluded);
        return restProps
    }
    render() {
        this.props;
        return viewFunction()
    }
}
GetterExtender.defaultProps = GetterExtenderProps;
